#
#Author: Edward Muller (edwardam@home.com edwardam@handhelds.org)
#Licnese: BSD (http://www.opensource.org/licenses/bsd-license.html)
#Date: 01/21/2001
#Program: date.py
#Version: 0.03
#
name = "Date\nTime"
desc = "Set Date & Time"
glade_file = 'date.glade'

from gtk import *
from GTK import *

from utils import *

_date_file = '/etc/lastdate'

class applet(Applet):

    global _date_file
    
    def __init__(self,glade_file):
        import time

        ctime = time.localtime(time.time())
        if ctime[0] < 2001:
            try:
                f = open(_date_file,'r')
                ctime = time.strptime(f.read(),"%a %b %d %H:%M:%S %Y")
                f.close()
            except:
                pass

        #Call the applet initializer
        Applet.__init__(self,glade_file)

        #Set some defaults for the widgets
        self.widgets['calendar'].select_month(ctime[1]-1,ctime[0])
        self.widgets['calendar'].select_day(ctime[2])
        self.widgets['hour'].get_adjustment().set_value(ctime[3])
        self.widgets['minute'].get_adjustment().set_value(ctime[4])
        self.widgets['second'].get_adjustment().set_value(ctime[5])

    def save(self,msgbox=FALSE):
        import time
        import os
        year, mo, day  = self.widgets['calendar'].get_date()
        hour = self.widgets['hour'].get_value_as_int()
        min = self.widgets['minute'].get_value_as_int()
        sec = self.widgets['second'].get_value_as_int()

        weekday = time.strptime('%d %d %d' % (mo+1,day,year),'%m %d %Y')[6]

        ctime = (year, mo + 1, day, hour, min, sec, weekday, 0, 0)

        ts = time.strftime("%a %b %d %H:%M:%S %Y",ctime)
        os.system('/bin/date -s "%s"' % ts)
        f = open(_date_file,'w')
        f.write(time.strftime("%a %b %d %H:%M:%S %Y",ctime))
        f.close()
        ret = Applet.save(self,msgbox)
                
applet_instance = applet(glade_file)
